Redmine - Defect #14361
Mercurial commit ids are short (12 digits) on database
2013-06-26 15:39 - Claudio Bley

Status: Closed Start date:

Priority: Normal Due date:

Assignee: Toshi MARUYAMA % Done: 100%
Category: SCM Estimated time: 0.00 hour
Target version: 25.0

Resolution: Fixed Affected version: 2.31
Description

I'm using redmine 2.3.1 and configured a Mercurial repository.

Referring to a commit with the changeset id (a 40 digit hexadecimal number) redmine does not render this as a link.

Furthermore, loading projects/$p/repository/revisions/$changeset_id just gives a 404 "The entry or revision was not found in the
repository." error.

Of course, the commit does exist in the repo.

select scmid from changesets; only gives the short-form ID, well, unsurprisingly.

To quote http://mercurial.selenic.com/wiki/ChangeSetID

Note: a short-form ID can start out valid, but become invalid because another changeset with the same prefix shows up later on. Do
not use short-form IDs for long-lived representations. You can use the --debug option to display the full changeset ID.

Associated revisions

Revision 12749 - 2014-02-01 05:23 - Toshi MARUYAMA

scm: mercurial: use 12 chars id for format_changeset_identifier (#14361)

Revision 12750 - 2014-02-01 07:08 - Toshi MARUYAMA

scm: mercurial: add check scmid to RepositoryMercurial Test#test_fetch_changesets_from_scratch (#14361)

Revision 12751 - 2014-02-01 08:46 - Toshi MARUYAMA

scm: mercurial: split Repository::Mercurial#latest_changesets_cond for short and long id (#14361)

Revision 12752 - 2014-02-01 08:47 - Toshi MARUYAMA

scm: mercurial: use long id in adapter level (#14361)

Revision 12753 - 2014-02-01 09:46 - Toshi MARUYAMA

back out r12752 (#14361)
Revision, Author and Comment of repository browser are broken.

Revision 12754 - 2014-02-02 01:40 - Toshi MARUYAMA

scm: split Repository#entries (#14361)

Revision 12755 - 2014-02-02 01:41 - Toshi MARUYAMA

scm: mercurial: add method to switch short or long id by existing value in DB (#14361)

Revision 12756 - 2014-02-02 05:43 - Toshi MARUYAMA

scm: mercurial: add adapter entry test (#14361)

Revision 12757 - 2014-02-02 05:43 - Toshi MARUYAMA

scm: mercurial: add model entries test (#14361)

Revision 12758 - 2014-02-02 05:43 - Toshi MARUYAMA

scm: mercurial: add model entry test (#14361)

Revision 12759 - 2014-02-02 05:44 - Toshi MARUYAMA

scm: mercurial: override entry and scm_entries (#14361)

Revision 12760 - 2014-02-02 05:44 - Toshi MARUYAMA

scm: mercurial: switch short or long id of entry by existing value in DB (#14361)

Revision 12761 - 2014-02-02 05:44 - Toshi MARUYAMA

scm: mercurial: use long id in adapter level (#14361)

Revision 12762 - 2014-02-02 07:34 - Toshi MARUYAMA

scm: mercurial: split latest_changesets tag test with limit or not (#14361)

Revision 12763 - 2014-02-02 07:34 - Toshi MARUYAMA

scm: mercurial: add latest_changesets "default" branch test (#14361)
Revision 12764 - 2014-02-02 08:56 - Toshi MARUYAMA

scm: mercurial: split latest_changesets tag test with path or not (#14361)

Revision 12765 - 2014-02-02 08:56 - Toshi MARUYAMA

scm: mercurial: split latest_changesets default branch test to sub method (#14361)

Revision 12766 - 2014-02-02 08:57 - Toshi MARUYAMA

scm: mercurial: split latest_changesets tag test to sub method (#14361)

Revision 12767 - 2014-02-02 12:40 - Toshi MARUYAMA

scm: mercurial: split test_entry_short_id to sub method (#14361)

Revision 12768 - 2014-02-02 12:40 - Toshi MARUYAMA

scm: mercurial: split test_entries_short_id to sub method (#14361)

Revision 12769 - 2014-02-02 12:41 - Toshi MARUYAMA

scm: mercurial: split test_copied_files to sub method (#14361)

Revision 12770 - 2014-02-02 12:41 - Toshi MARUYAMA

scm: mercurial: split test_parents to sub method (#14361)

Revision 12771 - 2014-02-02 13:19 - Toshi MARUYAMA

scm: mercurial: add test helper method to switch short or long id (#14361)

Revision 12772 - 2014-02-02 13:19 - Toshi MARUYAMA

scm: mercurial: use scmid_for_assert in assert_copied_files (#14361)

Revision 12773 - 2014-02-02 13:19 - Toshi MARUYAMA

scm: mercurial: use scmid_for_assert in assert_entry (#14361)

Revision 12774 - 2014-02-02 13:20 - Toshi MARUYAMA

scm: mercurial: use scmid_for_assert in assert_entries (#14361)
Revision 12775 - 2014-02-02 13:20 - Toshi MARUYAMA

scm: mercurial: use scmid_for_assert in assert_parents (#14361)

Revision 12776 - 2014-02-02 14:08 - Toshi MARUYAMA

scm: mercurial: add asserting first and last changeset to test_fetch_changesets_from_scratch (#14361)

Revision 12777 - 2014-02-02 15:53 - Toshi MARUYAMA

scm: mercurial: insert long id to DB unless existing id in DB is not short id (#14361)

History

#1 - 2013-06-26 15:44 - Toshi MARUYAMA

- Subject changed from hg commit ids not supported to Mercurial commit ids are short (12 chars) on database

#2 - 2013-06-26 15:51 - Toshi MARUYAMA
- Target version set to 2.4.0

#3 - 2013-06-26 17:25 - Toshi MARUYAMA
- File long-node.diff added

Try this patch.

#4 - 2013-06-26 19:36 - Toshi MARUYAMA
- File long-node-v2.diff added

This patch fixes some bugs of previous patch.

#5 - 2013-06-28 14:41 - Claudio Bley
- Status changed from New to Resolved

Toshi MARUYAMA wrote:

This patch fixes some bugs of previous patch.

It works great. Thank you very much!

One last thing though, would it be possible to shorten the link text to 12 (or even less) chars when on display? Maybe display it like

5cc4b7a91915...

As a human a 40 chars hex number is just not something one can grasp, usually.
For example git uses 7 digits by default (more when there's a conflict), and bitbucket also displays 7 digits in its web interface.

Should | add a new ticket about this?

Thanks, again.

#6 - 2013-07-23 22:43 - Mischa The Evil
- Status changed from Resolved to Confirmed

Correcting status; this is not yet committed.

#7 - 2013-10-13 10:02 - Jean-Philippe Lang
- Assignee set to Toshi MARUYAMA

Toshi, should we commit this for 2.4.0?

#8 - 2013-10-13 10:11 - Toshi MARUYAMA
- Target version deleted (2.4.0)

Jean-Philippe Lang wrote:

Toshi, should we commit this for 2.4.0?

Sorry, | don't have a time.

#9 - 2013-10-13 10:13 - Toshi MARUYAMA

My patch breaks some tests and need to add more tests.

#10 - 2013-10-13 10:14 - Jean-Philippe Lang

OK no problem, thanks.

#11 - 2014-01-31 16:34 - Claudio Bley
- File redmine_hg_long ids_tests.diff added

Hi.

Just wanted to check in on you whether you made some progress on this one?

| tried the patch on the latest release and it still applies perfectly.
I'm attaching a patch which removes one minor nit and also fixes all the failing tests.

Hope you get to include this into the next release... :)

Cheers.

#12 - 2014-02-01 08:31 - Toshi MARUYAMA

- Subject changed from Mercurial commit ids are short (12 chars) on database to Mercurial commit ids are short (12 digits) on database

#13 - 2014-02-03 03:49 - Toshi MARUYAMA
- Target version set to 2.5.0
- % Done changed from 0 to 100

#14 - 2014-02-23 09:21 - Jean-Philippe Lang

Toshi, can we close this one?

#15 - 2014-02-23 09:48 - Toshi MARUYAMA

- Status changed from Confirmed to Closed
- Resolution set to Fixed

In repository which created before 2.4, commit id length keeps 12 digits.
New repository which created after 2.5, commit id length is full (40 digits).

Files

long-node.diff 5.22 KB 2013-06-26 Toshi MARUYAMA

long-node-v2.diff 8.71 KB 2013-06-26 Toshi MARUYAMA

redmine_hg_long_ids_tests.diff 10.9 KB 2014-01-31 Claudio Bley
